#ifndef _TIHEX_H
#define _TIHEX_H

/*
   	TIHex v0.41
    Copyright (C) 2004 Jonas Gehring
    This programm uses functions from ExtGraph v2.00beta2 and TIChess by TIChessTeam
        
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Header File
// Created 08.04.04; 17:31:46

// Sprites (made with SpriteArtist 68k by Aleph Mobius):
unsigned short num1light[]={0xFFFF, 0xFFFF, 0xF7FF, 0xEFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF};
unsigned short num1dark[]={0x0, 0x0, 0x800, 0x1800, 0x800, 0x800, 0x0, 0x0};

unsigned short num2light[]={0xFFFF, 0xFFFF, 0xEFFF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF};
unsigned short num2dark[]={0x0, 0x0, 0x1800, 0x800, 0x1000, 0x1800, 0x0, 0x0};

unsigned short curs1light[]={0xFFFF, 0xF7BF, 0xF19F, 0xF01F, 0xE00F, 0xC007, 0xC007, 0x8003, 0xE003, 0xF001, 0xF801, 0xF807, 0xF83F, 0xF3FF, 0xFFFF, 0xFFFF};
unsigned short curs1dark[]={0x0, 0x840, 0xE60, 0xFE0, 0x1FF0, 0x3FF8, 0x3FF8, 0x7FFC, 0x1FFC, 0xFFE, 0x7FE, 0x7F8, 0x7C0, 0xC00, 0x0, 0x0};

unsigned short curs2light[]={0xFFFF, 0xF0FF, 0xF01F, 0xF801, 0xF001, 0x3, 0x3, 0x8007, 0x8007, 0xC00F, 0xC01F, 0xE09F, 0xE7BF, 0xFFFF, 0xFFFF, 0xFFFF};
unsigned short curs2dark[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};

unsigned char icon1light[]={0xFF, 0xC3, 0x81, 0x0, 0x81, 0xC3, 0xFF, 0xFF};
unsigned char icon1dark[]={0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

unsigned char icon2light[]={0xFF, 0xC3, 0x81, 0x0, 0x81, 0xC3, 0xFF, 0xFF};
unsigned char icon2dark[]={0xFF, 0xC3, 0x81, 0x0, 0x81, 0xC3, 0xFF, 0xFF};

// Constants
#define TITLE "TIHex"
#define VERSION "v0.41"

#define NUM_HEIGHT 8
#define CURS_HEIGHT 16

// Enumerations
enum wininformation {PLAYER1_HAS_WON = 1, PLAYER2_HAS_WON, NEW_GAME, EXIT, UNDO};
enum player {PLAYER_1 = 1, PLAYER_2};
enum graphx {CLEAR = 45, DRAW, FULL};
enum keys {KEY_OPTIONS = 103, KEY_NEW = 115, KEY_UNDO = 117,KEY_ABOUT = 97, KEY_VIEW = 118, KEY_LEFTX = 337, KEY_RIGHTX = 340, KEY_UPX = 338, KEY_DOWNX = 344, KEY_PLUS = 43, KEY_MINUS = 45, KEY_OUT = 265};
enum fonts {SMALL = F_4x6, MEDIUM = F_6x8};

// Funtions
void _main(void);
void _startend(void);
void DecompRLEVert(unsigned char *src, unsigned char *dest, int size);
void _drawcoin(int kind, int xpos, int ypos, int mode);
int _startgame(void);
void _nsprite(int num);
int _keywait(void);
void _movedown(void);
void _moveright(void);
void _moveup(void);
void _moveleft(void);
int _setcoin(void);
void _checkfield(int mode);
void _about(void);
void _redraw(void);
int _proof(void);
int _menu(void);
void _clearfield(void);
int _CheckHexPlayer1(int s, int i);
int _CheckHexPlayer2(int s, int i);
void _drawrect(int high);
void _undo(void);

// Field picture data: (Compressed in vertical RLE using ImageStudio2 by Cullen Sauls)
unsigned char field1[] = {
0x00,0x00,0x00,0x3C,0x61,0x6D,0x3F,0x00,0x7C,0x91,0x00,0x7A,0x99,0xDB,0xDF,0x7D,
0x91,0x00,0x7C,0x78,0x70,0x70,0x78,0x91,0x00,0x7C,0x05,0x0D,0x0D,0x07,0x00,0x0F,
0x91,0x00,0x31,0x01,0x91,0x00,0x48,0xEB,0x6B,0x5B,0x4B,0x00,0x80,0x91,0x00,0x2D,
0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x91,0x00,0x44,0xCE,0xD3,0xD3,0xDE,
0x91,0x00,0x2B,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,
0x40,0x20,0x10,0x0F,0x91,0x00,0x40,0x01,0x03,0x03,0x06,0x00,0x07,0x91,0x00,0x25,
0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,
0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x91,0x00,0x3C,0x3C,0xBD,0xBD,0xFD,
0x00,0xC0,0x91,0x00,0x21,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,
0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,
0x10,0xE0,0x10,0x08,0x04,0x03,0x91,0x00,0x38,0xE5,0x3D,0x3D,0xE7,0x91,0x00,0x1F,
0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x91,0x00,0x34,0xF8,0x20,0x20,0x20,
0x91,0x00,0x1C,0x01,0x02,0x04,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,
0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,
0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,
0x02,0x01,0x91,0x00,0x4E,0x01,0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,
0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,
0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,
0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,0x02,0x01,0x91,0x00,0x48,0x01,0x7E,0x81,
0x91,0x00,0x05,0x81,0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x81,0x91,0x00,0x05,0x81,
0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x81,0x91,0x00,
0x05,0x81,0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x01,0x91,0x00,0x42,0x3F,0x40,0x80,
0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,
0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,
0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,
0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,0x00,0x80,0x40,0x3F,0x91,0x00,
0x3B,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,
0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,
0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,
0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,
0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x91,0x00,0x33,0x0F,0x10,0x20,
0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,
0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,
0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,
0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,
0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x91,0x00,
0x2F,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,
0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,
0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,
0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,
0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,
0x20,0xC0,0x91,0x00,0x33,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,
0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,
0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,
0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,
0x04,0x03,0x04,0x08,0x10,0xE0,0x10,0x08,0x04,0x03,0x04,0x08,0x10,0xE0,0x91,0x00,
0x3B,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,
0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,
0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,
0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,0x08,0xF0,0x08,0x04,0x02,0x01,0x02,0x04,
0x08,0xF0,0x91,0x00,0x43,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,
0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,
0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,
0x01,0x00,0x01,0x02,0x04,0xF8,0x04,0x02,0x01,0x00,0x01,0x02,0x04,0xF8,0x91,0x00,
0x4B,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,
0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,
0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,0x02,0xFC,0x02,0x01,0x00,0x00,0x00,0x01,
0x02,0xFC,0x91,0x00,0x52,0x80,0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x81,0x91,0x00,
0x05,0x81,0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x81,0x91,0x00,0x05,0x81,0x7E,0x81,
0x91,0x00,0x05,0x81,0x7E,0x80,0x91,0x00,0x58,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,
0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,
0x00,0x80,0x40,0x3F,0x40,0x80,0x00,0x00,0x00,0x80,0x40,0x3F,0x40,0x80,0x91,0x00,
0x5E,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,
0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,0x00,0x80,0x40,0x20,0x1F,0x20,0x40,0x80,
0x91,0x00,0x64,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,
0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x0F,0x10,0x20,0x40,0x80,0x91,0x00,0x3C,0x0F,
0x0D,0x0F,0x0C,0x91,0x00,0x2B,0xC0,0x20,0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x20,
0x10,0x08,0x07,0x08,0x10,0x20,0xC0,0x91,0x00,0x40,0x43,0x43,0x47,0x7C,0x91,0x00,
0x2F,0xE0,0x10,0x08,0x04,0x02,0x04,0x08,0x10,0xE0,0x91,0x00,0x44,0x6B,0x3B,0x93,
0x93,0x91,0x00,0x7C,0xFC,0xA4,0xBC,0xBC,0x91,0x00,0xFF,0x91,0x00,0x7A
};

unsigned char field2[] = {
0xFF,0xFF,0xFF,0xCB,0x9E,0x9F,0xE8,0x91,0xFF,0x7C,0xEF,0xAD,0x65,0x87,0x91,0xFF,
0x7C,0xC7,0xCF,0xCF,0xD7,0x91,0xFF,0x7C,0xFA,0xF3,0xF3,0xFD,0x91,0xFF,0x7C,0x54,
0xFC,0xFC,0xFD,0x91,0xFF,0x7C,0xBD,0x7C,0x7C,0x6B,0x91,0xFF,0x7D,0xFD,0xFE,0xF9,
0x91,0xFF,0x7C,0xCB,0x47,0xC7,0x16,0x91,0xFF,0x7C,0xDA,0xC3,0xC3,0xBD,0x91,0xFF,
0x7C,0x67,0x91,0xFF,0xFF,0x91,0xFF,0xFF,0x91,0xFF,0xFF,0x91,0xFF,0xFF,0x91,0xFF,
0xFF,0x91,0xFF,0xFF,0x91,0xFF,0xFF,0x91,0xFF,0x86,0xF5,0xF3,0xF4,0xF3,0x91,0xFF,
0x7C,0xFC,0xFF,0xFB,0xCF,0x91,0xFF,0x7C,0x9E,0xE6,0x7E,0xFE,0x91,0xFF,0x7C,0x97,
0x5F,0x5B,0x47,0x91,0xFF,0xFF,0x91,0xFF,0x7A
};

// Compressed 7680 bytes to 1271. 16% of original size.







#endif